import BaseHTTPServer
import sys
import socket


class HTTP6Server(BaseHTTPServer.HTTPServer):
  address_family = socket.AF_INET6


class BackendHandler(BaseHTTPServer.BaseHTTPRequestHandler):
  response = 'ThisIsResponse' * 10

  def do_GET(self):
    self.send_response(200)
    self.send_header('X-Frame-Options', 'SAMEORIGIN')
    self.send_header('X-Content-Type-Options', 'nosniff')
    self.send_header('Access-Control-Allow-Origin', self.server.CORS_ORIGIN)
    self.end_headers()
    if self.path == '/test':
      self.wfile.write(self.response)
    else:
     self.wfile.write('Hello!')


def show_help():
  print 'Invoke: %s ip port cors' % (sys.argv[0])


if __name__ == '__main__':
  if len(sys.argv) != 4:
    show_help()
    sys.exit(1)
  ip, port, cors = sys.argv[1:]
  if ':' in ip:
    ip_ = '[%s]' % (ip,)
    server = HTTP6Server
  else:
    ip_ = ip
    server = BaseHTTPServer.HTTPServer
  print 'Serving on http://%s:%s/ with CORS set to %s' % (
    ip_, port, cors)
  server = server(
      (ip, int(port)),
      BackendHandler)
  server.CORS_ORIGIN = cors
  server.serve_forever()
